

Class TLAN08VM

    Public err As Integer = 0
    Private recvBuff As String = ""
    Private sendBuff As String = ""


    Private ipAddr As System.Net.IPAddress
    Private portNum As Integer

    Private sock As System.Net.Sockets.Socket
    Private endpoint As System.Net.IPEndPoint

    Private EtherComThread As System.Threading.Thread
    Private loopThread As Boolean = True

    Private cs = New Object()


    'RXgN^
    Public Sub New(ByVal distIp As String, ByVal distPort As Integer)

        'IPAhX`FbN
        Try
            ipAddr = System.Net.IPAddress.Parse(distIp)

        Catch ex As ArgumentNullException
            MsgBox("ipString is Nothing.", , "error")
            err = 1
            Return

        Catch ex As FormatException
            MsgBox("ipString is not a valid IP address.", , "error")
            err = 1
            Return
        End Try


        '|[gԍ`FbN
        If distPort < 0 And distPort > 65535 Then
            MsgBox("PortNumberString is not a valid port number.", , "error")
            err = 1
            Return
        End If

        portNum = distPort

        sock = New System.Net.Sockets.Socket(System.Net.Sockets.AddressFamily.InterNetwork, _
                                              System.Net.Sockets.SocketType.Stream, _
                                              System.Net.Sockets.ProtocolType.Tcp _
                                             )

        'M^CAEg3bɐݒ
        sock.SetSocketOption(Net.Sockets.SocketOptionLevel.Socket, Net.Sockets.SocketOptionName.ReceiveTimeout, 3000)
        sock.SetSocketOption(Net.Sockets.SocketOptionLevel.Socket, Net.Sockets.SocketOptionName.SendTimeout, 3000)

        'connectŗplbg[NGh|Cg
        endpoint = New System.Net.IPEndPoint(ipAddr, portNum)

        '\PbgubLOɂ
        sock.Blocking = False


        Dim ws2error As Integer

        'mubLOɂ̂Connect͑SocketExceptionWSAEWOULDBLOCKԂ
        Try
            sock.Connect(endpoint)

        Catch ex As System.Net.Sockets.SocketException
            ws2error = ex.ErrorCode()

        End Try


        '^CAEg3bsockɏ݂ł邩mF
        If Not sock.Poll(3000000, Net.Sockets.SelectMode.SelectWrite) Then

            MsgBox("Timeout - Socket.Connect()", , "error")
            sock.Close()
            err = 1
            Return

        End If


        sock.Blocking = True

        Dim recvbuf(2048) As Byte

        '͂߂">"mF
        Try
            sock.Receive(recvbuf)

        Catch ex As System.Net.Sockets.SocketException

            'M^CAEgƂ݂Ȃ
            MsgBox("Timeout - Socket.Receive()", , "error")
            err = 1
            Return
        End Try

        recvBuff = System.Text.Encoding.GetEncoding("US-ASCII").GetString(recvbuf)

        If recvBuff.IndexOf(">") = -1 Then
            sock.Close()
            MsgBox(""" > "" was not received.", , "error")
            err = 1
            Return
        End If

        recvBuff = ""


        sock.Blocking = False


        'ʐMpɕʃXbhp
        EtherComThread = New System.Threading.Thread(New System.Threading.ThreadStart(AddressOf EtherComMethod))

        EtherComThread.Start()
        'ȍ~sockEtherComMethodł삵Ȃ
        'Mobt@recvBuffƑMobt@sendBuffւ̃ANZX̓NeBJZNVɓ邱

        Return

    End Sub


    'vO}ĂяõNX̏I
    Public Sub Close()

        loopThread = False

        If Not EtherComThread Is Nothing Then
            EtherComThread.Join()
        End If

        If Not sock Is Nothing Then
            sock.Close()
        End If

        EtherComThread = Nothing
        sock = Nothing
        endpoint = Nothing

        cs = Nothing

    End Sub




    Private Sub EtherComMethod()

        Dim recvbuf(2048) As Byte
        Dim ws2error As Integer
        Dim read As Integer

        While loopThread

            'Mobt@NA
            Array.Clear(recvbuf, 0, recvbuf.Length)

            'M
            Try
                read = sock.Receive(recvbuf)

            Catch ex As System.Net.Sockets.SocketException

                ws2error = ex.ErrorCode()

                If ws2error <> 10035 Then       'WSAEWOULDBLOCKȊO̗O
                    MsgBox("Error - Socket.Receive() at EtherComMethod", , "error")
                    err = 1
                    Return
                End If
            End Try

            'Mf[^𐮌`ĎMɏ
            Dim tmp As String = System.Text.Encoding.GetEncoding("US-ASCII").GetString(recvbuf)
            tmp = tmp.Substring(0, tmp.IndexOf(vbNullChar))

            If read <> 0 Then
                System.Threading.Monitor.Enter(cs)
                recvBuff = recvBuff & tmp
                System.Threading.Monitor.Exit(cs)
            End If


            'Mf[^ΑM
            System.Threading.Monitor.Enter(cs)

            If sendBuff <> "" Then
                sock.Send(System.Text.Encoding.GetEncoding("US-ASCII").GetBytes(sendBuff))
                'OĂ
                sendBuff = ""
            End If

            System.Threading.Monitor.Exit(cs)


            System.Threading.Thread.Sleep(5)

        End While

    End Sub




    'Mobt@1(">"">"ɋ܂ꂽ)ǂݏo
    'Ō̉s͏
    'obt@ɂЂƂȂꍇ-1Ԃ
    Public Function Read(ByRef readstr As String)

        System.Threading.Monitor.Enter(cs)

        '">"T
        Dim findGt As Integer = recvBuff.IndexOf(">")
        While findGt = 0
            recvBuff = recvBuff.Substring(1)
            findGt = recvBuff.IndexOf(">")
        End While


        If findGt <> -1 Then
            readstr = recvBuff.Substring(0, findGt - 1)

            If findGt >= recvBuff.Length - 1 Then    'Mobt@">"̂
                recvBuff = ""
            Else                                    'Mobt@1ȏ㗭܂Ă
                recvBuff = recvBuff.Substring(findGt + 1)
            End If

        Else                                        'Mobt@">"Ȃ
            readstr = ""
        End If



        '񖖔̉s폜
        Dim findCrLf As Integer = readstr.LastIndexOf(vbCrLf)

        If findCrLf <> -1 Then                   'CRLF̂Ƃ
            If findCrLf = readstr.Length - 2 Then
                readstr = readstr.Substring(0, findCrLf)
            End If
        Else
            findCrLf = readstr.LastIndexOf(vbLf)
            If findCrLf = -1 Then
                findCrLf = readstr.LastIndexOf(vbCr)
            End If

            If findCrLf <> -1 Then               'CRLF̂Ƃ
                If findCrLf = readstr.Length - 1 Then
                    readstr = readstr.Substring(0, findCrLf)
                End If
            End If
        End If


        System.Threading.Monitor.Exit(cs)
        Return findGt

    End Function



    '𑗐Mobt@ɒǋL
    Public Sub Write(ByVal str As String)

        System.Threading.Monitor.Enter(cs)
        sendBuff = sendBuff & str
        System.Threading.Monitor.Exit(cs)

    End Sub


    'Mobt@NA
    Public Sub ClrBuff()

        System.Threading.Monitor.Enter(cs)
        recvBuff = ""
        System.Threading.Monitor.Exit(cs)

    End Sub

    Protected Overrides Sub Finalize()
        MyBase.Finalize()
    End Sub
End Class




Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows tH[ fUCiŐꂽR[h "

    Public Sub New()
        MyBase.New()

        ' ̌Ăяo Windows tH[ fUCiŕKvłB
        InitializeComponent()

        ' InitializeComponent() Ăяǒɏǉ܂B

    End Sub

    ' Form  dispose I[o[ChăR|[lgꗗ܂B
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows tH[ fUCiŕKvłB
    Private components As System.ComponentModel.IContainer

    '  : ȉ̃vV[ẂAWindows tH[ fUCiŕKvłB
    ' Windows tH[ fUCigĕύXĂB  
    ' R[h GfB^͎gpȂłB
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents REPEAT_CNT As System.Windows.Forms.TextBox
    Friend WithEvents CH_INTERVAL As System.Windows.Forms.TextBox
    Friend WithEvents CH0_EN As System.Windows.Forms.CheckBox
    Friend WithEvents CH1_EN As System.Windows.Forms.CheckBox
    Friend WithEvents CH2_EN As System.Windows.Forms.CheckBox
    Friend WithEvents CH3_EN As System.Windows.Forms.CheckBox
    Friend WithEvents CH7_EN As System.Windows.Forms.CheckBox
    Friend WithEvents CH6_EN As System.Windows.Forms.CheckBox
    Friend WithEvents CH5_EN As System.Windows.Forms.CheckBox
    Friend WithEvents CH4_EN As System.Windows.Forms.CheckBox
    Friend WithEvents IP As System.Windows.Forms.TextBox
    Friend WithEvents PORT As System.Windows.Forms.TextBox
    Friend WithEvents TEST As System.Windows.Forms.Button
    Friend WithEvents BREAK As System.Windows.Forms.Button
    Friend WithEvents CH0 As System.Windows.Forms.TextBox
    Friend WithEvents CH1 As System.Windows.Forms.TextBox
    Friend WithEvents CH3 As System.Windows.Forms.TextBox
    Friend WithEvents CH2 As System.Windows.Forms.TextBox
    Friend WithEvents CH7 As System.Windows.Forms.TextBox
    Friend WithEvents CH6 As System.Windows.Forms.TextBox
    Friend WithEvents CH5 As System.Windows.Forms.TextBox
    Friend WithEvents CH4 As System.Windows.Forms.TextBox
    Friend WithEvents Label4 As System.Windows.Forms.Label
    Friend WithEvents Label5 As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.IP = New System.Windows.Forms.TextBox()
        Me.PORT = New System.Windows.Forms.TextBox()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.TEST = New System.Windows.Forms.Button()
        Me.REPEAT_CNT = New System.Windows.Forms.TextBox()
        Me.CH_INTERVAL = New System.Windows.Forms.TextBox()
        Me.CH0_EN = New System.Windows.Forms.CheckBox()
        Me.CH1_EN = New System.Windows.Forms.CheckBox()
        Me.CH2_EN = New System.Windows.Forms.CheckBox()
        Me.CH3_EN = New System.Windows.Forms.CheckBox()
        Me.CH7_EN = New System.Windows.Forms.CheckBox()
        Me.CH6_EN = New System.Windows.Forms.CheckBox()
        Me.CH5_EN = New System.Windows.Forms.CheckBox()
        Me.CH4_EN = New System.Windows.Forms.CheckBox()
        Me.BREAK = New System.Windows.Forms.Button()
        Me.CH0 = New System.Windows.Forms.TextBox()
        Me.CH1 = New System.Windows.Forms.TextBox()
        Me.CH3 = New System.Windows.Forms.TextBox()
        Me.CH2 = New System.Windows.Forms.TextBox()
        Me.CH7 = New System.Windows.Forms.TextBox()
        Me.CH6 = New System.Windows.Forms.TextBox()
        Me.CH5 = New System.Windows.Forms.TextBox()
        Me.CH4 = New System.Windows.Forms.TextBox()
        Me.Label4 = New System.Windows.Forms.Label()
        Me.Label5 = New System.Windows.Forms.Label()
        Me.SuspendLayout()
        '
        'IP
        '
        Me.IP.Location = New System.Drawing.Point(72, 15)
        Me.IP.Name = "IP"
        Me.IP.Size = New System.Drawing.Size(152, 19)
        Me.IP.TabIndex = 0
        Me.IP.Text = "192.168.0.90"
        Me.IP.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
        '
        'PORT
        '
        Me.PORT.Location = New System.Drawing.Point(296, 15)
        Me.PORT.Name = "PORT"
        Me.PORT.Size = New System.Drawing.Size(56, 19)
        Me.PORT.TabIndex = 4
        Me.PORT.Text = "56346"
        Me.PORT.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(240, 16)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(48, 16)
        Me.Label2.TabIndex = 13
        Me.Label2.Text = "PORT #"
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(16, 16)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(48, 16)
        Me.Label1.TabIndex = 12
        Me.Label1.Text = "IP Addr"
        '
        'TEST
        '
        Me.TEST.Location = New System.Drawing.Point(368, 13)
        Me.TEST.Name = "TEST"
        Me.TEST.TabIndex = 14
        Me.TEST.Text = "Test"
        '
        'REPEAT_CNT
        '
        Me.REPEAT_CNT.HideSelection = False
        Me.REPEAT_CNT.Location = New System.Drawing.Point(96, 47)
        Me.REPEAT_CNT.Name = "REPEAT_CNT"
        Me.REPEAT_CNT.Size = New System.Drawing.Size(136, 19)
        Me.REPEAT_CNT.TabIndex = 19
        Me.REPEAT_CNT.Text = "10"
        Me.REPEAT_CNT.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
        '
        'CH_INTERVAL
        '
        Me.CH_INTERVAL.Location = New System.Drawing.Point(360, 48)
        Me.CH_INTERVAL.Name = "CH_INTERVAL"
        Me.CH_INTERVAL.Size = New System.Drawing.Size(136, 19)
        Me.CH_INTERVAL.TabIndex = 27
        Me.CH_INTERVAL.Text = "10"
        Me.CH_INTERVAL.TextAlign = System.Windows.Forms.HorizontalAlignment.Center
        '
        'CH0_EN
        '
        Me.CH0_EN.Location = New System.Drawing.Point(16, 96)
        Me.CH0_EN.Name = "CH0_EN"
        Me.CH0_EN.Size = New System.Drawing.Size(120, 24)
        Me.CH0_EN.TabIndex = 29
        Me.CH0_EN.Text = "CH0"
        '
        'CH1_EN
        '
        Me.CH1_EN.Location = New System.Drawing.Point(176, 96)
        Me.CH1_EN.Name = "CH1_EN"
        Me.CH1_EN.Size = New System.Drawing.Size(120, 24)
        Me.CH1_EN.TabIndex = 30
        Me.CH1_EN.Text = "CH1"
        '
        'CH2_EN
        '
        Me.CH2_EN.Location = New System.Drawing.Point(328, 96)
        Me.CH2_EN.Name = "CH2_EN"
        Me.CH2_EN.Size = New System.Drawing.Size(120, 24)
        Me.CH2_EN.TabIndex = 31
        Me.CH2_EN.Text = "CH2"
        '
        'CH3_EN
        '
        Me.CH3_EN.Location = New System.Drawing.Point(480, 96)
        Me.CH3_EN.Name = "CH3_EN"
        Me.CH3_EN.Size = New System.Drawing.Size(120, 24)
        Me.CH3_EN.TabIndex = 32
        Me.CH3_EN.Text = "CH3"
        '
        'CH7_EN
        '
        Me.CH7_EN.Location = New System.Drawing.Point(480, 288)
        Me.CH7_EN.Name = "CH7_EN"
        Me.CH7_EN.Size = New System.Drawing.Size(120, 24)
        Me.CH7_EN.TabIndex = 36
        Me.CH7_EN.Text = "CH7"
        '
        'CH6_EN
        '
        Me.CH6_EN.Location = New System.Drawing.Point(328, 288)
        Me.CH6_EN.Name = "CH6_EN"
        Me.CH6_EN.Size = New System.Drawing.Size(120, 24)
        Me.CH6_EN.TabIndex = 35
        Me.CH6_EN.Text = "CH6"
        '
        'CH5_EN
        '
        Me.CH5_EN.Location = New System.Drawing.Point(176, 288)
        Me.CH5_EN.Name = "CH5_EN"
        Me.CH5_EN.Size = New System.Drawing.Size(120, 24)
        Me.CH5_EN.TabIndex = 34
        Me.CH5_EN.Text = "CH5"
        '
        'CH4_EN
        '
        Me.CH4_EN.Location = New System.Drawing.Point(16, 288)
        Me.CH4_EN.Name = "CH4_EN"
        Me.CH4_EN.Size = New System.Drawing.Size(120, 24)
        Me.CH4_EN.TabIndex = 33
        Me.CH4_EN.Text = "CH4"
        '
        'BREAK
        '
        Me.BREAK.DialogResult = System.Windows.Forms.DialogResult.No
        Me.BREAK.Enabled = False
        Me.BREAK.Location = New System.Drawing.Point(456, 13)
        Me.BREAK.Name = "BREAK"
        Me.BREAK.TabIndex = 37
        Me.BREAK.Text = "Break"
        '
        'CH0
        '
        Me.CH0.AcceptsReturn = True
        Me.CH0.AllowDrop = True
        Me.CH0.Location = New System.Drawing.Point(16, 120)
        Me.CH0.Multiline = True
        Me.CH0.Name = "CH0"
        Me.CH0.ReadOnly = True
        Me.CH0.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.CH0.Size = New System.Drawing.Size(144, 152)
        Me.CH0.TabIndex = 38
        Me.CH0.Text = ""
        '
        'CH1
        '
        Me.CH1.AcceptsReturn = True
        Me.CH1.AllowDrop = True
        Me.CH1.Location = New System.Drawing.Point(168, 120)
        Me.CH1.Multiline = True
        Me.CH1.Name = "CH1"
        Me.CH1.ReadOnly = True
        Me.CH1.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.CH1.Size = New System.Drawing.Size(144, 152)
        Me.CH1.TabIndex = 39
        Me.CH1.Text = ""
        '
        'CH3
        '
        Me.CH3.AcceptsReturn = True
        Me.CH3.AllowDrop = True
        Me.CH3.Location = New System.Drawing.Point(472, 120)
        Me.CH3.Multiline = True
        Me.CH3.Name = "CH3"
        Me.CH3.ReadOnly = True
        Me.CH3.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.CH3.Size = New System.Drawing.Size(144, 152)
        Me.CH3.TabIndex = 41
        Me.CH3.Text = ""
        '
        'CH2
        '
        Me.CH2.AcceptsReturn = True
        Me.CH2.AllowDrop = True
        Me.CH2.Location = New System.Drawing.Point(320, 120)
        Me.CH2.Multiline = True
        Me.CH2.Name = "CH2"
        Me.CH2.ReadOnly = True
        Me.CH2.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.CH2.Size = New System.Drawing.Size(144, 152)
        Me.CH2.TabIndex = 40
        Me.CH2.Text = ""
        '
        'CH7
        '
        Me.CH7.AcceptsReturn = True
        Me.CH7.AllowDrop = True
        Me.CH7.Location = New System.Drawing.Point(472, 312)
        Me.CH7.Multiline = True
        Me.CH7.Name = "CH7"
        Me.CH7.ReadOnly = True
        Me.CH7.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.CH7.Size = New System.Drawing.Size(144, 152)
        Me.CH7.TabIndex = 45
        Me.CH7.Text = ""
        '
        'CH6
        '
        Me.CH6.AcceptsReturn = True
        Me.CH6.AllowDrop = True
        Me.CH6.Location = New System.Drawing.Point(320, 312)
        Me.CH6.Multiline = True
        Me.CH6.Name = "CH6"
        Me.CH6.ReadOnly = True
        Me.CH6.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.CH6.Size = New System.Drawing.Size(144, 152)
        Me.CH6.TabIndex = 44
        Me.CH6.Text = ""
        '
        'CH5
        '
        Me.CH5.AcceptsReturn = True
        Me.CH5.AllowDrop = True
        Me.CH5.Location = New System.Drawing.Point(168, 312)
        Me.CH5.Multiline = True
        Me.CH5.Name = "CH5"
        Me.CH5.ReadOnly = True
        Me.CH5.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.CH5.Size = New System.Drawing.Size(144, 152)
        Me.CH5.TabIndex = 43
        Me.CH5.Text = ""
        '
        'CH4
        '
        Me.CH4.AcceptsReturn = True
        Me.CH4.AllowDrop = True
        Me.CH4.Location = New System.Drawing.Point(16, 312)
        Me.CH4.Multiline = True
        Me.CH4.Name = "CH4"
        Me.CH4.ReadOnly = True
        Me.CH4.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.CH4.Size = New System.Drawing.Size(144, 152)
        Me.CH4.TabIndex = 42
        Me.CH4.Text = ""
        '
        'Label4
        '
        Me.Label4.Location = New System.Drawing.Point(16, 48)
        Me.Label4.Name = "Label4"
        Me.Label4.Size = New System.Drawing.Size(80, 16)
        Me.Label4.TabIndex = 46
        Me.Label4.Text = "Repert Count"
        '
        'Label5
        '
        Me.Label5.Location = New System.Drawing.Point(256, 49)
        Me.Label5.Name = "Label5"
        Me.Label5.Size = New System.Drawing.Size(88, 16)
        Me.Label5.TabIndex = 47
        Me.Label5.Text = "Channel Interval"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.ClientSize = New System.Drawing.Size(634, 479)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.Label5, Me.Label4, Me.CH7, Me.CH6, Me.CH5, Me.CH4, Me.CH3, Me.CH2, Me.CH1, Me.CH0, Me.BREAK, Me.CH7_EN, Me.CH6_EN, Me.CH5_EN, Me.CH4_EN, Me.CH3_EN, Me.CH2_EN, Me.CH1_EN, Me.CH0_EN, Me.CH_INTERVAL, Me.REPEAT_CNT, Me.IP, Me.TEST, Me.Label2, Me.Label1, Me.PORT})
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
        Me.MaximizeBox = False
        Me.Name = "Form1"
        Me.Text = "VBSAMPLE"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private tlan08vm As tlan08vm
    Private UpdateWindowsThread As System.Threading.Thread

    Private loopThread As Boolean = True

    Dim ch As Byte
    Dim chCnt As Integer
    Dim lastCh As Integer

    Private Sub BTNPC_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TEST.Click

        DisableConfigForms()

        CH0.Text = ""
        CH1.Text = ""
        CH2.Text = ""
        CH3.Text = ""
        CH4.Text = ""
        CH5.Text = ""
        CH6.Text = ""
        CH7.Text = ""

        ch = 0
        chCnt = 0

        If CH0_EN.Checked Then
            ch = ch + 1
            chCnt = chCnt + 1
            lastCh = 0
        End If
        If CH1_EN.Checked Then
            ch = ch + 2
            chCnt = chCnt + 1
            lastCh = 1
        End If
        If CH2_EN.Checked Then
            ch = ch + 4
            chCnt = chCnt + 1
            lastCh = 2
        End If
        If CH3_EN.Checked Then
            ch = ch + 8
            chCnt = chCnt + 1
            lastCh = 3
        End If
        If CH4_EN.Checked Then
            ch = ch + 16
            chCnt = chCnt + 1
            lastCh = 4
        End If
        If CH5_EN.Checked Then
            ch = ch + 32
            chCnt = chCnt + 1
            lastCh = 5
        End If
        If CH6_EN.Checked Then
            ch = ch + 64
            chCnt = chCnt + 1
            lastCh = 6
        End If
        If CH7_EN.Checked Then
            ch = ch + 128
            chCnt = chCnt + 1
            lastCh = 7
        End If


        '`FbN̓`lȂꍇ͂ȂɂȂ
        If chCnt = 0 Then
            EnableConfigForms()
            Return
        End If

        'JԂƃ`lԊu`FbN
        If Not (Integer.Parse(REPEAT_CNT.Text) >= 0 And Integer.Parse(CH_INTERVAL.Text) >= 2) Then
            EnableConfigForms()
            Return
        End If


        'MpNXnew
        tlan08vm = New TLAN08VM(IP.Text, PORT.Text)
        If tlan08vm.err Then
            tlan08vm.Close()
            tlan08vm = Nothing

            EnableConfigForms()

            Return
        End If


        'TLAN-08VMFIFOfo
        Dim i As Integer
        For i = 0 To 7
            tlan08vm.Write("conv read ch" & i & vbCrLf)
        Next

        '荞ݐݒTLAN-08VMɑM
        tlan08vm.Write("set ch " & ch & vbCrLf)
        tlan08vm.Write("set re " & REPEAT_CNT.Text & vbCrLf)
        tlan08vm.Write("set interval " & CH_INTERVAL.Text & vbCrLf)
        tlan08vm.Write("set cyc " & (chCnt * Integer.Parse(CH_INTERVAL.Text)) & vbCrLf)

        'ϊJnR}h
        tlan08vm.Write("conv begin" & vbCrLf)

        If tlan08vm.err Then
            tlan08vm.Close()
            tlan08vm = Nothing

            EnableConfigForms()

            Return
        End If

        System.Threading.Thread.Sleep(1500)

        tlan08vm.ClrBuff()

        '\XVpXbhX^[g
        loopThread = True
        UpdateWindowsThread = New System.Threading.Thread(New System.Threading.ThreadStart(AddressOf UpdateWindowsMethod))
        UpdateWindowsThread.Start()


    End Sub


    Private Sub BREAK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BREAK.Click

        Dim i As Integer

        tlan08vm.Write("conv end" & vbCrLf)

        System.Threading.Thread.Sleep(250)

        If Not UpdateWindowsThread Is Nothing Then
            loopThread = False
            UpdateWindowsThread.Join()
            UpdateWindowsThread = Nothing
        End If

        tlan08vm.Close()
        tlan08vm = Nothing

        EnableConfigForms()

    End Sub


    '\XVpXbh
    Private Sub UpdateWindowsMethod()

        Dim recvBuff As String
        Dim sendBuff As String
        Dim i As Integer
        Dim currentTextBox As TextBox

        System.Threading.Thread.Sleep(100)

        While loopThread
            For i = 0 To 7

                If ch And 2 ^ i Then

                    Select Case i
                        Case 0
                            currentTextBox = CH0
                        Case 1
                            currentTextBox = CH1
                        Case 2
                            currentTextBox = CH2
                        Case 3
                            currentTextBox = CH3
                        Case 4
                            currentTextBox = CH4
                        Case 5
                            currentTextBox = CH5
                        Case 6
                            currentTextBox = CH6
                        Case 7
                            currentTextBox = CH7
                    End Select


                    'ǂݎR}hM
                    sendBuff = "conv read ch" & i & vbCrLf
                    tlan08vm.Write(sendBuff)

                    '"Empty buffer""OK"ȊO܂ŎM
                    While True
                        System.Threading.Thread.Sleep(90)

                        'G[ꍇ͎~߂
                        If tlan08vm.err Then
                            tlan08vm.Close()
                            tlan08vm = Nothing
                            EnableConfigForms()
                            Return
                        End If

                        tlan08vm.Read(recvBuff)

                        If Not (recvBuff.StartsWith("Empty buffer") Or recvBuff.StartsWith("OK") Or recvBuff = "") Then
                            Exit While
                        ElseIf recvBuff.StartsWith("Empty buffer") Or recvBuff.StartsWith("OK") Then
                            tlan08vm.Write(sendBuff)
                        End If

                        'r~̏
                        If Not loopThread Then
                            recvBuff = ""
                            Exit While
                        End If

                    End While


                    'M\
                    If recvBuff <> "" Then
                        currentTextBox.Text = currentTextBox.Text & recvBuff & vbCrLf
                        currentTextBox.SelectionStart = currentTextBox.Text.Length
                        currentTextBox.ScrollToCaret()
                    End If

                    If Integer.Parse(REPEAT_CNT.Text) > 0 Then
                        If i = lastCh Then
                            If currentTextBox.Lines.Length > Integer.Parse(REPEAT_CNT.Text) Then
                                tlan08vm.Write("conv end" & vbCrLf)
                                tlan08vm.Close()
                                tlan08vm = Nothing
                                loopThread = False
                                EnableConfigForms()
                            End If
                        End If
                    End If

                End If
            Next
        End While

    End Sub



    Private Sub EnableConfigForms()

        TEST.Enabled = True
        BREAK.Enabled = False

        IP.Enabled = True
        PORT.Enabled = True
        REPEAT_CNT.Enabled = True
        CH_INTERVAL.Enabled = True

        CH0_EN.Enabled = True
        CH1_EN.Enabled = True
        CH2_EN.Enabled = True
        CH3_EN.Enabled = True
        CH4_EN.Enabled = True
        CH5_EN.Enabled = True
        CH6_EN.Enabled = True
        CH7_EN.Enabled = True

    End Sub



    Private Sub DisableConfigForms()

        TEST.Enabled = False
        BREAK.Enabled = True

        IP.Enabled = False
        PORT.Enabled = False
        REPEAT_CNT.Enabled = False
        CH_INTERVAL.Enabled = False

        CH0_EN.Enabled = False
        CH1_EN.Enabled = False
        CH2_EN.Enabled = False
        CH3_EN.Enabled = False
        CH4_EN.Enabled = False
        CH5_EN.Enabled = False
        CH6_EN.Enabled = False
        CH7_EN.Enabled = False

    End Sub


End Class


